#!/bin/bash

# copyright for this file is GPLv3+ belonging to Jon Bendtsen jonbendtsen@jonix.dk
# copyright for the mac_audit application does not belong to me (Jon),
# but to someone else, see this url for a little more information
# http://www.open-audit.org/phpBB3/viewtopic.php?f=5&t=3678&p=16659


exit_code=0

cd ~/Library/open_mac_audit
exit_code=$?
if [ 0 -ne "$exit_code" ]; then
  echo "no working directory ~/Library/open_mac_audit"
  exit 1
fi

last_update=$(find mac.txt -atime +23h30m 2>&1)
if [ -n "$last_update" ]; then
  # okay, the last update is either non-existing or more than 1 day old,
  # we execute the mac_audit program and try to post data to the servers
  # listed in ./servers.cfg
  ./mac_audit 2> /dev/null
  OLDIFS=$IFS
  IFS="
"
  posted_to=""
  for server in $(grep -v "^#" servers.cfg); do
    curl --fail --insecure --silent --data-urlencode add@mac.txt -o /dev/null "$server"
    exit_code=$?
    if [ 0 -eq "$exit_code" ]; then
      posted_to="$server"
      exit_code=0
      break
      # okay, this server accepted the data, no need to try any more
    fi
  done
  IFS=$OLDIFS
fi
if [ -z "$posted_to" ]; then
  echo "open_mac_audit data not posted to any server"
  exit_code=2
fi
exit $exit_code
